	SUBTITLE "Board specific definitions"
;------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2003,eugene@ksf.kiev.ua
;      Revision:  V0.01
;      Date:      Feb 25, 2003
;      Assembler: MPASM version 3.20.07
;------------------------------------------------------------
; Board/schematic and desing specific definitions
;------------------------------------------------------------

#define CLOCK .4000000

; PORT mapping
; RS232 ports, interrupts are not used for RS communication
; Flow control is used instead
#define	RX	PORTB,0			; RX Pin,  RB0, input 
#define	TX	PORTB,1			; TX Pin,  RB1, output
#define CTS PORTB,2			; CTS pin, RB2, output 
#define RTS PORTB,6			; RTS pin, RB6, input

#define UI_PORT PORTA
#define UI_SEL0	PORTA, 0		; speed selector 1
#define UI_SEL1 PORTA, 1		; speed selector 2
#define UI_LEDOK0 PORTA, 2		; send/speed indicator
#define UI_LEDOK1 PORTA, 3		; recieve/speed indicator
#define UI_LEDERR PORTA, 4		; ERROR LED (red)
#define	AP_DTR	PORTB, 3		; DTR signal used for selecting which test to run
#define UI_TRIS B'11100011'
;LEDERR       -------+||||
;LEDOK1       --------+|||
;LEDOK0       ---------+||
;SWTCH1       ----------+|
;SWTCH0       -----------+

#define RS_TRIS  B'11111001'; RB1 connected to +V, RB3 ro 0V
				;  |||||||+--- RX, inp
				;  ||||||+---- TX, out
				;  |||||+----- CTS, out
				;  ||||+------ DTR, inp
				;  |||+------- NC
				;  ||+-------- NC
				;  |+--------- RTS, inp
				;  +---------- NC

#define AP_OPTION_REG B'10000111';
; ~RBPU ----------------+|||||||			disable pull up
; INTEDG ----------------+||||||			interrupt on falling edge
; T0CS -------------------+|||||			Timer, not counter
; T0SE --------------------+||||			do not care
; PSA ----------------------+|||			prescaler on TMR0 
; PS2-PS0 -------------------+++			prescaler = 256
