           SUBTITLE        "Processor specific definitions"
;
;------------------------------------------------------------
; File Name :      PIC.asm
;------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2003,eugene@ksf.kiev.ua
;      Revision:  V0.01
;      Date:      Feb 25, 2003
;      Assembler: MPASM version 3.20.07
;------------------------------------------------------------
;
; ----------------------------------------------------------
; Processor specific, board/schema independed, 
;     application independed primitives.
; ----------------------------------------------------------

; ----------------------------------------------------------
; PIC16F84A
			include         "p16f84a.inc"
; ----------------------------------------------------------

#define step		1

nope	macro		; nop 2 cycles long
	goto $+step
  endm
  
loop	macro	
	goto $-step
 endm
 
skip	macro
	goto $+ 2*step
 endm

ei		macro
	bsf		INTCON, GIE
  endm

di		macro
	bcf		INTCON, GIE
  endm

; enable timer interrupts
TMR0_ei		macro
	bsf		INTCON, T0IE
  endm

; disable timer interrupts
TMR0_di		macro
	bcf		INTCON, T0IE
  endm

; clear timer flag
TMR0_cf		macro
	bcf		INTCON, T0IF
  endm

TMR0_skpc macro
	btfsc	INTCON, T0IF
  endm

TMR0_skps macro
	btfss	INTCON, T0IF
  endm

TMR0_clr macro
	clrf	TMR0
  endm

; ----------------------------------------------------------
; PORT B primitives

; enable port interrupts
PORT_ei		macro
	bsf		INTCON, RBIE
  endm

; disable port interrupts
PORT_di		macro
	bcf		INTCON, RBIE
  endm

; clear port interrupt flag
PORT_cf		macro
	bcf		INTCON, RBIF
  endm

; test port interrupt flag skip if set
PORT_skpIF		macro
	bcf		INTCON, RBIF
  endm

; test port interrupt flag skip if not set
PORT_skpnIF		macro
	bcf		INTCON, RBIF
  endm

; ----------------------------------------------------------
; INTerrrupt primitives

INT_ei macro
	bsf		INTCON, INTE
  endm

INT_di macro
	bcf		INTCON, INTE
  endm

INT_cf macro
	bcf		INTCON, INTF
  endm

INT_skpIF macro
	btfss	INTCON, INTF
  endm

INT_skpnIF macro
	btfsc	INTCON, INTF
  endm

; ----------------------------------------------------------
; INDF primitives
;
; store file into indirect location, increment FSR
INDF_put macro file			; *FSR++ = file
	movf	file, W
	movwf	INDF
	incf	FSR, F
  endm

; load FSR with a literal pointing to a constant location
INDF_setl macro file
	movlw	file
	movwf	FSR
  endm

; load FSR with a file pointing to a location
INDF_setf macro file
	movf	file, W
	movwf	FSR
  endm

